package dist;

import utils.Utils;
/**
 * Created by IntelliJ IDEA.
 * User: dragomir yankov
 * Date: Jun 17, 2005
 * Time: 4:07:00 PM
 * To change this template use File | Settings | File Templates.
 */
public class DistEuclidean extends Dist {

    public DistEuclidean(boolean earlyAbandon, boolean normalize) {
        this.earlyAbandon = earlyAbandon;
        this.normalized = normalize;
    }

    public double dist(double[] timeseries1, double[] timeseries2) {
        double[] ts1 = timeseries1;
        double[] ts2 = timeseries2;
        if (normalized) {
            ts1 = Utils.znormalize(ts1, 0, ts1.length);
            ts2 = Utils.znormalize(ts2, 0, ts2.length);
        }
        double d = 0;
        for (int i = 0; i < ts1.length; i++) {
            d += (ts1[i] - ts2[i]) * (ts1[i] - ts2[i]);
            if (this.earlyAbandon && d >= this.currMinDist) {
                break;
            }
        }
        if (currMinDist > d) {
            currMinDist = d;
        }
        return Math.sqrt(d);
    }

    /**
     * The method is used when the currentMinDist so far is updated to be the distance to the k-th nearest neighbor
     * (rather than the 1NN) 
     */
    public double dist(double[] timeseries1, double[] timeseries2, double currMinDist) {
        double[] ts1 = timeseries1;
        double[] ts2 = timeseries2;
        if (normalized) {
            ts1 = Utils.znormalize(ts1, 0, ts1.length);
            ts2 = Utils.znormalize(ts2, 0, ts2.length);
        }
        double d = 0;
        currMinDist *= currMinDist;
        for (int i = 0; i < ts1.length; i++) {
            d += (ts1[i] - ts2[i]) * (ts1[i] - ts2[i]);
            if (this.earlyAbandon && d >= currMinDist) {
                d = currMinDist;
                break;
            }
        }
        if (earlyAbandon && d > currMinDist) {
            d = currMinDist;
        }
        return Math.sqrt(d);
    }
}

