package dist;

import utils.Utils;

/**
 * Created by IntelliJ IDEA.
 * User: yankov
 * Date: Aug 6, 2007
 * Time: 2:17:49 PM
 * To change this template use File | Settings | File Templates.
 */
public class DistRotational extends Dist {
    private DistEuclidean innerDist = null;

    public DistRotational(boolean normalize) {
        super();
        this.normalized = normalize;
    }

    public double dist(double[] timeseries1, double[] timeseries2) {
        innerDist = new DistEuclidean(true, false);
        rotation = 0;
        double[] ts1 = timeseries1;
        double[] ts2 = timeseries2;
        if (normalized) {
            ts1 = Utils.znormalize(ts1, 0, ts1.length);
            ts2 = Utils.znormalize(ts2, 0, ts2.length);
        }
        double d = Double.MAX_VALUE;
        for (int i = 0; i < ts2.length; i++) {
            double[] ts3 = new double[ts2.length];
            int len = ts2.length - i;
            System.arraycopy(ts2, i, ts3, 0, len);
            System.arraycopy(ts2, 0, ts3, len, i);
            double tmpd = innerDist.dist(ts1, ts3);
            if (tmpd < d) {
                d = tmpd;
                rotation = i;
            }
        }
        return d;
    }
}
