package utils;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.text.DecimalFormat;
import java.util.Vector;

/**
 * Created by IntelliJ IDEA.
 * User: dragomir
 * Date: Sep 30, 2005
 * Time: 12:03:18 PM
 * To change this template use File | Settings | File Templates.
 */
public class IOUtils {
    public static DecimalFormat df;
    public static DecimalFormat df4;
    public static DecimalFormat df12;

    static {
        df = new DecimalFormat("#.#");//DecimalFormat.getInstance();
        df.setDecimalSeparatorAlwaysShown(false);
        df.setMaximumFractionDigits(2);

        df4 = new DecimalFormat("#.#");//DecimalFormat.getInstance();
        df4.setDecimalSeparatorAlwaysShown(false);
        df4.setMaximumFractionDigits(4);

        df12 = new DecimalFormat("#.#");//DecimalFormat.getInstance();
        df12.setDecimalSeparatorAlwaysShown(false);
        df12.setMaximumFractionDigits(12);
    }

    public static String dblToStr(double dbl) {
        return df.format(dbl);
    }


    public static void writeln(FileOutputStream fos, double[][] arr, String header) {
        write(fos, arr, header);
        try {
            fos.write("\n".getBytes());
            fos.flush();
        } catch (Exception e) {
            //do nothing
        }
    }

    public static void write(FileOutputStream fos, double[][] arr, String header) {
        String str = writeToString(arr, header);
        try {
            fos.write(str.getBytes());
            fos.flush();
        } catch (IOException e) {
            //do nothing
        }
    }

    public static void writeln(FileOutputStream fos, double[] arr, String header) {
        write(fos, arr, header);
        try {
            fos.write("\n".getBytes());
            fos.flush();
        } catch (IOException e) {
            //do nothing
        }
    }

    public static void write(FileOutputStream fos, double[] arr, String header) {
        String str = writeToString(arr, header);
        try {
            fos.write(str.getBytes());
            fos.flush();
        } catch (IOException e) {
            //do nothing
        }
    }

    public static String writeToString(double[] arr, String header) {
        String str = header;
        for (int i = 0; i < arr.length; i++) {
            str += " " + df.format(arr[i]);
        }
        return str;
    }

    public static String writeToString(double[][] arr, String header) {
        String str = header;
        for (int i = 0; i < arr.length; i++) {
            if (arr[i] == null) {
                str += "null";
            }
            for (int j = 0; j < arr[i].length; j++) {
                str += " " + df.format(arr[i][j]);
            }
            str += "\t";
        }
        return str;
    }

    public static double[][] readDblDbl(String file) {
        try {
            Vector v = new Vector();
            RandomAccessFile f = new RandomAccessFile(file, "r");
            String line = "";
            while ((line = f.readLine()) != null) {
                double[] arr = strToDbl(line);
                v.add(arr);
            }
            f.close();
            return Utils.toDblDblArray(v);
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static double[] strToDbl(String str) {
        String[] sdbl = str.split(" ");
        Vector v = new Vector();
        for (int i = 0; i < sdbl.length; i++) {
            try {
                Double d = new Double(sdbl[i]);
                v.add(d);
            } catch (Exception e) {}
        }
        return Utils.toDoubleArray(v);
    }

    public static double[] readDbl(String file) {
        try {
            Vector v = new Vector();
            RandomAccessFile f = new RandomAccessFile(file, "r");
            String line = "";
            while ((line = f.readLine()) != null) {
                Double d = new Double(line.trim());
                v.add(d);
            }
            f.close();
            return Utils.toDoubleArray(v);
        } catch (Exception e) {
            return null;
        }
    }

    public static void writeln(FileOutputStream fos, double val, String header) {
        String str = header + df.format(val) + "\n";
        try {
            fos.write(str.getBytes());
            fos.flush();
        } catch (IOException e) {
            //do nothing
        }
    }
    public static void write(FileOutputStream fos, double val, String header) {
        String str = header + df.format(val);
        try {
            fos.write(str.getBytes());
            fos.flush();
        } catch (IOException e) {
            //do nothing
        }
    }
}
